$('#tutorial').on('click', function () {
  $(document).ready(async function () {
    const driver = new Driver({
      doneBtnText: 'Sair',
      closeBtnText: 'Fechar',
      nextBtnText: 'Próximo',
      prevBtnText: 'Anterior',
      allowClose: false
    });
    driver.defineSteps([

      {
        element: '#btnFiltros',
        popover: {
          title: 'Botão Filtros',
          description: 'Clique aqui para filtrar a consulta.',
          position: 'right'
        }
      },
      {
        element: '#btnIncluir',
        popover: {
          title: 'Botão Incluir',
          description: 'Clique aqui para iniciar o cadastro de uma Área .',
          position: 'right'
        }
      },
      {
        element: '#tabelaCentroCustoValor',
        popover: {
          title: 'Tabela Solicitações',
          description: 'Aqui estão os dados das solicitações cadastradas.',
          position: 'top'
        }
      }
    ]);
    driver.start();
  });
});

$(document).ready(async function () {

  $('#txtCodigo').autocompleta(1, `JSON={ "tabela":"CENTROCUSTO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
  $('#btnCodigo').pesquisa('#txtCodigo', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"CENTROCUSTO", "camposSelect":[ "CODIGO", "DESCRICAO", "GRUPO", "ESTRUTURA", "TIPO", "OBS",  "RESPONSAVEL", "PRODUTIVO" ]}`, 'Pesquisa de Centro de Custo', 'CENTROCUSTO');
  $('#btnLimpaCodigo').on('click', function () {
    $('#txtCodigo').val('');
  });

  $('#btnFiltros').on('click', function () {
    $('#modal-filtros').modal('show');
  });

  $('#btnLimparFiltros').on('click', function () {
    $('#txtCodigo').val('');
  });

  const permissaoUsuarioLogado = await permissaoAcessos("CENTROCUSTOVALOR");

  await fazConsulta();

  $('#btnConsultar').on('click', async function () {
    $('#modal-filtros').modal('hide');
    await fazConsulta();
  });

  // $('#btnIncluir').on('click', function () {
  //   if (permissaoUsuarioLogado.INCLUI == 'S') {
  //     window.location.href = "centrocustovalor/create";
  //   } else {
  //     msgAlertaSemConfirmacao("Sem permissão para incluir!");
  //   }
  // });

  async function fazConsulta() {
    try {
      $.LoadingOverlay("show");
      let response;
      let codigo = pegaChave('#txtCodigo') != '' ? ` AND CODIGO = '${pegaChave('#txtCodigo')}'` : '';

      response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ "tabela":"CENTROCUSTO", "camposSelect":[ "CODIGO", "DESCRICAO", "GRUPO", "ESTRUTURA", "TIPO", "OBS",  "RESPONSAVEL", "PRODUTIVO" ], "where": ["1=1 ${codigo}"]}`, null);

      if (!response) {
        $.LoadingOverlay("hide");
        return;
      }

      let jsonStr = await response.json();
      if (response.status != 200) {
        $.LoadingOverlay("hide");
        msgAlerta(jsonStr.RESULT[0].mensagem);
        return;
      }

      $("#tabelaCentroCustoValor").DataTable({
        destroy: true,
        lengthChange: false,

        autoWidth: true,
        data: jsonStr.RESULT[0],
        columns: [
          {
            title: "Código",
            data: "CODIGO",
         },
         {
            title: "Descrição",
            data: "DESCRICAO",
         },
         {
            title: "Estrutura",
            data: "ESTRUTURA",
         },
        //  {
        //     title: "Grupo",
        //     data: "GRUPO",
        //  },
        //  {
        //     title: "Tipo",
        //     data: "TIPO",
        //  },
        //  {
        //     title: "Obs.",
        //     data: "OBS",
        //  },
        //  {
        //     title: "Responsável",
        //     data: "RESPONSAVEL",
        //  },
        //  {
        //     title: "Produtivo",
        //     data: "PRODUTIVO",
        //  },
        ],
        columnDefs: [
          {
            targets: [0], render: function (data, type, row) {
              return retornaBotaoOpcoes(data);
            }
          },
        ],
      });
      $.LoadingOverlay("hide");
    } catch (error) {
      console.error(error);
      $.LoadingOverlay("hide");
    }
  }

  $("#tabelaCentroCustoValor").unbind("click");

  // $('#tabelaCentroCustoValor').on('click', '#btn-excluir', async function () {
  //   if (permissaoUsuarioLogado.EXCLUI == 'S') {
  //     msgAlerta('Você realmente deseja excluir esse registro?', async () => {
  //       const data = $("#tabelaCentroCustoValor").DataTable().row($(this).parents("tr"));
  //       await excluiRegistro(data);
  //     });
  //   } else {
  //     msgAlertaSemConfirmacao("Sem permissão para excluir!");
  //   }
  // });

  $("#tabelaCentroCustoValor").on('click', '#btn-editar', async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaCentroCustoValor").DataTable().row($(this).parents("tr")).data();
      window.location.href = `centrocustovalor/${data.CODIGO}`;
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }
  });



  $("#tabelaCentroCustoValor").on("dblclick", "tr", async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaCentroCustoValor").DataTable().row($(this)).data();
      window.location.href = `centrocustovalor/${data.CODIGO}`;
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }
  });

  // async function excluiRegistro(data) {
  //   try {
  //     $.LoadingOverlay("show");
  //     try {
  //       let valorLinha = data.data();
  //       let response = await requisicao("DELETE", "/sisplan/cadastros/v1/centrocustovalor?", `CODIGO=${encodeURIComponent(valorLinha.CODIGO)}`, null);
  //       if (!response) {
  //         return;
  //       }
  //       if (response.status != 200) {
  //         let jsonStr = await response.json();
  //         msgAlerta(jsonStr.mensagem);
  //         return;
  //       }

  //       toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
  //         toastClass: "success",
  //         iconClasses: {
  //           error: "alert-error",
  //           info: "alert-info",
  //           success: "alert-success",
  //           warning: "alert-warning",
  //         },
  //         positionClass: "toast-top-center",
  //         progressBar: true,
  //         timeOut: 3000,
  //         fadeOut: 1000,
  //         onHidden() {
  //           data.remove().draw(false);
  //         },
  //       }).css({
  //         "margin-top": "20%",
  //         width: "500px",
  //         "max-width": "500px",
  //       });

  //     } catch (error) {
  //       console.error(error);
  //     }
  //   } finally {
  //     $.LoadingOverlay("hide");
  //   }
  // }

  function retornaBotaoOpcoes(data) {
    var retorno = '<div style="text-align:start;"> ' +
      '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" id="tutorialTabela" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
      '      ' + data + ' ' +
      '    </button> ' +
      '    <div class="dropdown-menu"> ' +
      '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
      // '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
      '</div>';
    return retorno;
  };

});